RevEx.revex.Content = function(body, website)
{
	this.arraytmp0 = new Array();
	this.arraytmp1 = new Array();
	this.arraytmp2 = new Array();
	this.arraytmp3 = new Array();
	
	this.ponderations = new Array();
	this.depth = 0;
	this.forbiddenNodes = new Array("NAV", "undefined", "HR", "EM", "BODY", "SCRIPT", "HEADER", "H1", "H2", "H3", "H4", "H5","iframe","form","style","STYLE","IMG","FORM","IFRAME","OPTION", "A","NOSCRIPT","SELECT","BUTTON","LABEL","SVG");
	this.distanceMax = 0;
	this.distanceNode = null;
	
	this.standardizedAvg = new Array(4);
	this.standardizedDeviation = new Array(4);

	this.threshold = 0;	
	this.posi = -1;
	this.oc = new RevEx.util.Hashtable();
	this.maxCluster = 0;	
	this.clusters = new Array();
	this.maxlevel = 0;
	this.differentGroups = new Array();
	this.finalValor = 0;
	
	this.euclidean = function(node1, node2){
		var total = 0;
		for (var i = 0; i < node1.ratio.length; i++)
			total = total + Math.pow(node1.ratio[i] - node2.ratio[i], 2);
		total = Math.sqrt(total);
		return total;
	}

	this.distance = function(node1, node2)
	{
		if (node1.ratio && node2.ratio && !node1.cluster){
			var valor = this.euclidean(node1, node2);
			if (valor >= this.distanceMax){
				this.distanceMax = valor; 
				this.distanceNode = node1.cloneNode(true);
				this.distanceNode.ratio = node1.ratio;
			}
		}
		var children = node1.childNodes;
		for (var i = 0; i < children.length; i++){  
			if(children[i].ratio)
				this.distance(children[i], node2);
		}
	}
	
	this.processContent = function(body)
	{	
		this.preprocess(body);
		this.posNode(body, 0);

		this.rateNode(body);

		for (var k=0; k < 4; k++){
			this.mean(body, k);
			this.standardizedAvg[k] = this.mean2(k);
			this.standardizedDeviation[k] = standardDeviation(this.returnVector(k));
		}
		
		this.standardizeNode(body);
		
		this.computeMatrix(body);
		this.removeLower(3);
		this.showGroups();
		this.markTree(body);
		this.computeRoots(body);
		
		//Potenciar el text (sense links) i el número de nodes repetits (se poden saber per .group crec). Mirar distància
		this.threshold = body.textContent.replace(/\s/g,'').length;
		this.assignValue(body);
		this.computeMax(body);		
		this.marcaHTML(body);
		return body;
	}
	
	this.markTree = function(node)
	{
		if (node && node.nodeType == 1){
			var ocurrenceEntries = this.oc.entries();
			for (var i = 0; i < ocurrenceEntries.length; i++){
				var vec = ocurrenceEntries[i];			
				if (vec[0] == node.posi){
					node.group = vec[1][1];
					//console.log("ocurrencia: " + vec[1][1]);	
				}
			}		
		}
		if (node && node.childNodes.length > 0){
			var children = node.childNodes;
			for (var i = 0; i < children.length; i++){
				this.markTree(children[i]);
			}
		}
	}
	
	this.checkDescendantGroup = function(node,group)
	{
		let count = 0;
		if (node && node.nodeType == 1)
			if (node.group == group)
				count++;

		if (node && node.childNodes.length > 0){
			var children = node.childNodes;
			for (var i = 0; i < children.length; i++){
				count += this.checkDescendantGroup(children[i],group);
			}
		}
		return count;
	}
	this.hasText = function(node)
	{
		var nodeName = node.nodeName.toLowerCase();
		if (nodeName != "#text")
			return false;

		var nodeText = node.nodeValue;
		return (nodeText != "");
	}	
	this.isHidden = function(node)
	{
		if (node.nodeType == 1){
			let condition = false;
			if (node.style)
				if (node.style.visibility === "hidden" || node.style.display === "none")
					condition = true;
			if (node.isHidden)
				condition = true;
				
			return condition;
		}
		else
			return !this.hasText(node);
	}
	
	this.isHidden2 = function(node)
	{
		while (node.tagName != "BODY"){
			if (!this.isHidden(node)){
				node = node.parentNode;
			}
			else
				return true;
		}
		return false;
	}

//CALCULAR PER A CADA FILL I FER LA MITJA
	this.assignValue = function(node)
	{
		if (node && node.clus && !this.isHidden2(node)){
			let nodes = this.countDescendants(node,true);
			let thresh = Math.sqrt(this.threshold / node.textContent.replace(/\s/g,'').length);
			let imag = this.linkWithImage2(node);
			if (imag == 0)
				imag = 1;
			let words = this.countTextNotLink3(node, node, true)/*nodes*/; //Cambiar el countWords i calcular les words que no tinguen una A de ancestor.
			this.differentGroups = [];
			let groups = this.countGroups(node);
			let lev = node.depth /* this.depth*/;

			let valor = words * groups * lev / imag;			
			node.finalval = valor;
		}
			
		if (node && node.childNodes.length > 0){
			var children = node.childNodes;
			for (var i = 0; i < children.length; i++){
				this.assignValue(children[i]);
			}
		}
	}		

	this.countGroups = function(node)
	{
		if (node && node.group){
			if (!this.differentGroups.includes(node.group))	//Se podria intentar comprovar si el node.group el conté algún altre nodo. Si no no s'afegeix
				this.differentGroups.push(node.group);
		}
			//count++;

		if (node && node.childNodes.length > 0){
			var children = node.childNodes;
			for (var i = 0; i < children.length; i++){
				this.countGroups(children[i]);
			}
		}
		return this.differentGroups.length;
	}	

	this.computeMax = function(node)
	{
		if (node && node.finalval){
			//alert(node.finalval + "---" + node.outerHTML);
			if ((node.finalval) > this.finalValor)
				this.finalValor = (node.finalval);
		}
		
		if (node && node.childNodes.length > 0){
			var children = node.childNodes;
			for (var i = 0; i < children.length; i++){
				this.computeMax(children[i]);
			}
		}
	}	
	
	this.marcaHTML = function(node)
	{
		if (node && node.clus)
			if ((node.finalval) == this.finalValor){
				node.final = 1;
				//alert(node.finalval + "---" + node.outerHTML);
			}else{
				node.final = 0;
			}

		if (node && node.childNodes.length > 0){
			var children = node.childNodes;
			for (var i = 0; i < children.length; i++){
				this.marcaHTML(children[i]);
			}
		}
	}	
	
	this.findValueInClustersArray = function(value)
	{
		var result;
		for( var i = 0, len = this.clusters.length; i < len; i++ ) {
			if( this.clusters[i][0] === value ) {
				result = this.clusters[i][1];
				break;
			}
		}	
		return result;		
	}
	
	this.computeRoots = function(node)
	{
		let node2 = node;
		if (node2 && node2.nodeType == 1){
			if (node2.group){
				let group = node2.group;
				let val = this.findValueInClustersArray(group);
				if (val > 0){
					//alert(node2.outerHTML);
					//alert(group + "-" + val);
					node2 = node2.parentNode;
					while((this.checkDescendantGroup(node2,group) < (val-1)) && node2.tagName != "BODY")
						node2 = node2.parentNode;

					if (this.checkDescendantGroup(node2,group) >= (val-1) && node2.tagName != "BODY"){
						node2.clus = group;
						//console.log("clus: " + node2.clus);
					}
				}
			}
		}
		if (node && node.childNodes.length > 0){
			var children = node.childNodes;
			for (var i = 0; i < children.length; i++){
				this.computeRoots(children[i]);
			}
		}
	}		
	
	this.showGroups = function(){
		let count2 = 0;
		for(let j=0; j<=this.maxCluster; j++){
			count = 0;
			var ocurrenceEntries = this.oc.entries();
			for (var i = 0; i < ocurrenceEntries.length; i++){
				var vec = ocurrenceEntries[i];			
				if (vec[1][1] == j)
					count++;
			}
			//console.log(j + "<->" + count);
			count2 = count2 + count;
		}
		//alert(count2);		
	}
	
	this.removeLower = function(thres){
		for(let j=0; j<=this.maxCluster; j++){
			count = 0;
			var ocurrenceEntries = this.oc.entries();
			for (var i = 0; i < ocurrenceEntries.length; i++){
				var vec = ocurrenceEntries[i];			
				if (vec[1][1] == j)
					count++;
			}
			//console.log(j + "<->" + count);
			if (count < thres){
				for (var i = 0; i < ocurrenceEntries.length; i++){
					var vec = ocurrenceEntries[i];			
					if (vec[1][1] == j)
						var ocurrence = this.oc.remove(vec[0]);
				}
			}else{
				let ar = [j,count];
				this.clusters.push(ar);
			}
		}
	}

	this.countWords3 = function(s){
		var count = !s ? 0 : (s.split(/^\s+$/).length === 2 ? 0 : 2 +
		s.split(/\s+/).length - s.split(/^\s+/).length - s.split(/\s+$/).length);
		return count; 
	}	
	this.showNode = function(node)
	{
		node.isHidden = false;
	}	
	this.checkAll = function (node1, node2)
	{
		let found = true;
		let children = node1.childNodes;
		for (var i = 0; i < children.length; i++){
			if(children[i].tagName != undefined && node2.tagName != undefined && children[i].firstChild != null){
				if (children[i].tagName != node2.tagName || children[i].firstChild.tagName != "A" || children[i].firstChild.nextSibling != null)
					if (children[i].firstChild.tagName != "A" && children[i].firstChild.textContent.trim().length == 0 && (this.linkWithImage2(children[i].firstChild) == 0))
						console.log("Del node");
					else
						found = false;
			}
		}
		return found;
	}
	this.linkWithImage2 = function(node)
	{
		var count = 0;
		if (node.tagName == "IMG" || node.tagName == "SVG"){
			count++;
		}
		if (node && node.childNodes.length > 0){
			var children = node.childNodes;
			for (var i = 0; i < children.length; i++){
				count += this.linkWithImage2(children[i]);
			}
		}
		return count;
	}	

	this.posNode = function(node, depth)
	{
		if (node && node.childNodes.length > 0){
			var children = node.childNodes;
			depth++;
			for (var i = 0; i < children.length; i++){  
				if(children[i].nodeType != 3){
					children[i].depth = depth;
					if (this.depth < depth)
						this.depth = depth;
					this.posNode(children[i], depth);
				}
			}
		}
	}

	this.standardizeNode = function(node1)
	{
		if (node1.ratio){
			if (this.standardizedDeviation[0] != 0)
				node1.ratio[0] = (node1.ratio[0] - this.standardizedAvg[0]) / this.standardizedDeviation[0];
			if (this.standardizedDeviation[1] != 0)
				node1.ratio[1] = (node1.ratio[1] - this.standardizedAvg[1]) / this.standardizedDeviation[1];
			if (this.standardizedDeviation[2] != 0)
				node1.ratio[2] = (node1.ratio[2] - this.standardizedAvg[2]) / this.standardizedDeviation[2];
			if (this.standardizedDeviation[3] != 0)
				node1.ratio[3] = (node1.ratio[3] - this.standardizedAvg[3]) / this.standardizedDeviation[3];
		}
		var children = node1.childNodes;
		for (var i = 0; i < children.length; i++){  
			if(children[i].ratio)
				this.standardizeNode(children[i]);
		}
	}	
	
	//Función creada por problemas en el uso de eval (problemas de seguridad)
	this.returnVector = function(k){
		if (k == 0)
			return this.arraytmp0;
		if (k == 1)
			return this.arraytmp1;
		if (k == 2)
			return this.arraytmp2;
		if (k == 3)
			return this.arraytmp3;			
	}
	
	this.mean = function(node1, j)
	{
		if (node1.ratio)
			this.returnVector(j).push(node1.ratio[j]);
		var children = node1.childNodes;
		for (var i = 0; i < children.length; i++){  
			if(children[i].ratio)
				this.mean(children[i], j);
		}
	}
	
	this.mean2 = function(j)
	{
		var tmpsuma = 0;
		for (var i = 0; i < this.returnVector(j).length;i++){
			tmpsuma += this.returnVector(j)[i];
		}
		return(tmpsuma/this.returnVector(j).length);
	}

	this.wordCount = function(str) { 
	  return str.split(" ").length;
	}	
	
	this.countWords = function(node, getChildrensChildren, origNode)
	{
		var counter = 0;
		var cadena = "";
		
		if ((node.nodeType == 3) && (node.parentNode.tagName != "A")){
			cadena = node.textContent.trim();
			var dist = this.distanceBetweenTwoNodes(node, origNode);
			counter = counter + (this.wordCount(cadena)/dist);
			cadena = "";
		}

		if (node && node.childNodes.length > 0){
			var children = node.childNodes.length;
			for(var i=0; i < children; i++){
				//if(node.tagName != "A"){
					if(getChildrensChildren)
						counter += this.countWords(node.childNodes[i],true, origNode);
				//}
			}
		}

		return counter;
	}
	
	this.distanceBetweenTwoNodes = function(node1,node2){
		var distance = 0;
		while (node1 != node2){
			node1 = node1.parentNode;
			distance++;
		}
		return distance;
	}
	
	this.rateNode = function(node)
	{
		if (node && node.childNodes.length > 0){
			var children = node.childNodes;
			if ((children.length >= 1) && (node.textContent.replace(/\s/g,'').length > this.threshold))
					if ((!RevEx.misc.Misc.arrayContains(this.forbiddenNodes, node.tagName )) && (node.nodeType != 3) && (node.display !== 'none') && (node.style.visibility !== 'hidden')){
						this.maxlevel = 0;
						this.countLevel(node);
						//console.log("level: " + (this.maxlevel-node.depth));
						if ((this.maxlevel-node.depth) >= 2/* && node.depth < (this.depth - 1)*/){
							node.ratio = this.computeNodeRatio(node);
							//console.log(node.ratio[0]);
							this.posi++;
							node.posi = this.posi;
						}
					}
				for (var i = 0; i < children.length; i++)
						this.rateNode(children[i]);
		}
	}
	
	this.countTerminals = function(node, getChildrensChildren, origNode)
	{
		var counter = 0;
		
		if (node.nodeType == 3){
			counter++;
		}

		else if (node && node.childNodes.length > 0){
			var children = node.childNodes.length;
			for(var i=0; i < children; i++){
				if(getChildrensChildren)
					counter += this.countTerminals(node.childNodes[i],true, origNode);
			}
		}
		return counter;
	}
	
	this.countDescendants = function(node, getChildrensChildren)
	{
		var counter = 0;
		
		if (node){
			counter++;
		}

		if (node && node.childNodes.length > 0){
			var children = node.childNodes.length;
			for(var i=0; i < children; i++){
				if(getChildrensChildren)
					counter += this.countDescendants(node.childNodes[i],true);
			}
		}
		return counter;
	}	
	
	this.countLevel = function(node)
	{
		if (node && node.depth > this.maxlevel){
			this.maxlevel = node.depth;
		}
		
		if (node.childNodes.length > 0){
			for(var i=0; i < node.childNodes.length; i++)
				this.countLevel(node.childNodes[i]);

		}
	}		
	
	this.countTags = function(node, getChildrensChildren)
	{
		var counter = 0;
		
		if (node.tagName == "A"){
			counter++;
		}

		else if (node && node.childNodes.length > 0){
			var children = node.childNodes.length;
			for(var i=0; i < children; i++){
				if(getChildrensChildren)
					counter += this.countTags(node.childNodes[i],true);
			}
		}
		return counter;
	}
	
	this.computeNodeRatio = function(node){
		var ratio = new Array();
		var contentProbability = 0;
		var nodos = node.getElementsByTagName("*").length;
		
		var terms = this.countTerminals(node, true, node);

		var countWords = this.countWords(node, true, node);
		
		var brothersProbability = node.childNodes.length;
		
		var descendants = this.countDescendants(node, true);

		var depthProbability = node.depth;
		
		ratio[0] = terms; 	//Ya
		ratio[1] = descendants;	//Ya
		ratio[2] = brothersProbability;	//Ya
		ratio[3] = depthProbability;	//Ya
		
		return ratio;
	}

	function standardDeviation(values){
	  var avg = average(values);
	  
	  var squareDiffs = values.map(function(value){
		var diff = value - avg;
		var sqrDiff = diff * diff;
		return sqrDiff;
	  });
	  
	  var avgSquareDiff = average(squareDiffs);

	  var stdDev = Math.sqrt(avgSquareDiff);
	  return stdDev;
	}

	function average(data){
	  var sum = data.reduce(function(sum, value){
		return sum + value;
	  }, 0);

	  var avg = sum / data.length;
	  return avg;
	}

	this.preprocess = function(node)
	{
		if (node.tagName == "SCRIPT" || node.tagName == "STYLE" || node.nodeType == 8 || node.nodeType == 4 || node.tagName == "NOSCRIPT"){
			node.parentNode.removeChild(node);
			return;
		}
		if (node.nodeType == 1){
			if (/*(node.id.search(/cookie/i) != -1) || */(node.classList.contains("cookie"))){
				node.parentNode.removeChild(node);
				return;		
			}
		}
		if (node && node.childNodes.length > 0){
			var children = node.childNodes;
			for (var i = 0; i < children.length; i++){
				this.preprocess(children[i]);
			}
		}
	}

	this.countTextNotLink3 = function(node, node2, getChildrensChildren)
	{
		var counter = 0;
		var cadena = "";
		
		if (node.nodeType == 3 && !this.isHidden2(node) && node.parentNode.tagName != "A"){
			cadena = node.nodeValue.replace(/\s/g, "");
			let dist = this.distanceBetweenTwoNodes(node,node2);
			counter = counter + (cadena.length/dist);
			cadena = "";
		}

		if (node && node.childNodes.length > 0){
			var children = node.childNodes.length;
			for(var i=0; i < children; i++){
				if(node.childNodes[i].tagName != "A" && !this.isHidden2(node.childNodes[i])){
					if(getChildrensChildren)
						counter += this.countTextNotLink3(node.childNodes[i],node2,true);
				}
			}
		}

		return counter;
	}	

	this.computeMatrix = function (node1)
	{
		//console.log("entra" + cluster);
		if (node1.ratio) 
			this.computeCentroid(node1, body);
		
		var children = node1.childNodes;
		for (var i = 0; i < children.length; i++){  
			if(children[i].ratio){
				this.maxCluster++;
				this.computeMatrix(children[i]);
			}
		}		
		
	}
	this.computeCentroid = function(node1, node2)
	{
		if (node1.ratio && node2.ratio){
			let valor = this.euclidean(node1, node2);

			if (valor == 0){

				var ocurrence = this.oc.remove(node1.posi);	
				var ocur = new Array();
				ocur.push(node1, this.maxCluster);
				this.oc.put(node1.posi, ocur);				

				var ocurrence = this.oc.remove(node2.posi);	
				var ocur = new Array();
				ocur.push(node2, this.maxCluster);
				this.oc.put(node2.posi, ocur);	
			}
		}

		var children = node2.childNodes;
		for (var i = 0; i < children.length; i++){
			if(children[i].ratio){
				this.computeCentroid(node1, children[i]);
			}
		}
	}

	return this.processContent(body);
}